/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.modules.guosen.bussiness.controller;

import cn.hutool.core.lang.Assert;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import lombok.AllArgsConstructor;
import javax.validation.Valid;

import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springblade.modules.guosen.bussiness.entity.BussinessBonusAccount;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.RequestParam;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.modules.guosen.bussiness.vo.BussinessBonusAccountVO;
import org.springblade.modules.guosen.bussiness.service.IBussinessBonusAccountService;
import org.springblade.core.boot.ctrl.BladeController;

import java.math.BigDecimal;
import java.util.List;

/**
 *  控制器
 *
 * @author BladeX
 * @since 2021-07-22
 */
@RestController
@AllArgsConstructor
@RequestMapping("cyzh-guosen/bussinessbonusaccount")
@Api(value = "", tags = "接口")
public class BussinessBonusAccountController extends BladeController {

	private final IBussinessBonusAccountService BussinessBonusAccountService;

	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入bussinessBonusAccount")
	public R<BussinessBonusAccount> detail(BussinessBonusAccount BussinessBonusAccount) {
		BussinessBonusAccount detail = BussinessBonusAccountService.getOne(Condition.getQueryWrapper(BussinessBonusAccount));
		return R.data(detail);
	}

	/**
	 * 分页
	 */
	@GetMapping("/list")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入bussinessBonusAccount")
	public R<IPage<BussinessBonusAccount>> list(BussinessBonusAccount BussinessBonusAccount, Query query) {
		IPage<BussinessBonusAccount> pages = BussinessBonusAccountService.page(Condition.getPage(query), Condition.getQueryWrapper(BussinessBonusAccount));
		return R.data(pages);
	}

	/**
	 * 自定义分页
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入bussinessBonusAccount")
	public R<IPage<BussinessBonusAccountVO>> page(BussinessBonusAccountVO BussinessBonusAccount, Query query) {
		IPage<BussinessBonusAccountVO> pages = BussinessBonusAccountService.selectBussinessBonusAccountPage(Condition.getPage(query), BussinessBonusAccount);
		return R.data(pages);
	}

	/**
	 * 新增
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入bussinessBonusAccount")
	public R save(@Valid @RequestBody BussinessBonusAccount BussinessBonusAccount) {
		return R.status(BussinessBonusAccountService.save(BussinessBonusAccount));
	}

	/**
	 * 修改
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入bussinessBonusAccount")
	public R update(@Valid @RequestBody BussinessBonusAccount BussinessBonusAccount) {
		return R.status(BussinessBonusAccountService.updateById(BussinessBonusAccount));
	}

	/**
	 * 新增或修改
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入bussinessBonusAccount")
	public R submit(@Valid @RequestBody BussinessBonusAccount bussinessBonusAccount) {
		if(bussinessBonusAccount.getId() != null){//编辑
			//统计所有比例是否超过1
			List<BussinessBonusAccount> BussinessBonusAccounts = BussinessBonusAccountService.getBaseMapper().selectList(new QueryWrapper<>(new BussinessBonusAccount()).lambda()
				.notIn(BussinessBonusAccount::getId, bussinessBonusAccount.getId()));
			BigDecimal total = BussinessBonusAccounts.stream().filter(
					bussinessBonusAccount1 -> bussinessBonusAccount1.getId() != bussinessBonusAccount.getId()
			).map(BussinessBonusAccount::getRate).reduce(BigDecimal.ZERO, BigDecimal::add);
			total = total.add(bussinessBonusAccount.getRate());
			Assert.isFalse(BigDecimal.ONE.compareTo(total) < 0,"总比例超过100%" );
			return R.status(BussinessBonusAccountService.updateById(bussinessBonusAccount));
		}else{//新增
			List<BussinessBonusAccount> BussinessBonusAccounts = BussinessBonusAccountService.getBaseMapper().selectList(new QueryWrapper<>(new BussinessBonusAccount()));
			BigDecimal total = BussinessBonusAccounts.stream().map(BussinessBonusAccount::getRate).reduce(BigDecimal.ZERO, BigDecimal::add);
			total = total.add(bussinessBonusAccount.getRate());
			Assert.isFalse(BigDecimal.ONE.compareTo(total) < 0,"总比例超过100%" );
			return R.status(BussinessBonusAccountService.save(bussinessBonusAccount));
		}
	}


	/**
	 * 删除
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
		return R.status(BussinessBonusAccountService.deleteLogic(Func.toLongList(ids)));
	}


}
